/**
 * The Message model module.
 * @module Ntnx/Message
 * @version 4.0.1
 * @class Message
 */
export default class Message {
    /**
     * Constructs a <code>Message</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:Ntnx/Message} obj Optional instance to populate.
     * @param callFromChild {Boolean} Flag to recognise calling instance
     * @return {module:Ntnx/Message} The populated <code>Message</code> instance.
     */
    static constructFromObject(data: any, obj?: any, callFromChild?: boolean): any;
    /**
    * Converts a given snake_case string to camelCase.
    * @param {string} snakeStr - The input string in snake_case format.
    * @returns {string} - The converted string in camelCase format.
    */
    static snakeToCamel(snakeStr: string): string;
    $objectType: string;
    /** @type {object<string, any>} */
    $reserved: object;
    /** @type {object<string, any>} */
    $unknownFields: object;
    /**
     * Returns A code that uniquely identifies a message.
     * @return {string}
     */
    getCode(): string;
    /**
     * Sets A code that uniquely identifies a message.
     * @param {string} code A code that uniquely identifies a message.
     */
    setCode(code: string): void;
    code: string;
    /**
     * Returns The description of the message.
     * @return {string}
     */
    getMessage(): string;
    /**
     * Sets The description of the message.
     * @param {string} message The description of the message.
     */
    setMessage(message: string): void;
    message: string;
    /**
     * Returns The locale for the message description.
     * @return {string}
     */
    getLocale(): string;
    /**
     * Sets The locale for the message description.
     * @param {string} locale The locale for the message description.
     */
    setLocale(locale: string): void;
    locale: string;
    /**
     * @return {MessageSeverity}
     */
    getSeverity(): MessageSeverity;
    /**
     * @param {MessageSeverity} severity
     */
    setSeverity(severity: MessageSeverity): void;
    severity: string;
    get$Reserved(): any;
    get$ObjectType(): string;
    get$UnknownFields(): any;
    toJson(forMutation: any): {
        $reserved: any;
        $objectType: string;
        $unknownFields: any;
        severity?: string;
        locale?: string;
        message?: string;
        code?: string;
    };
    validate(scope: any, properties: any, ...args: any[]): Promise<any>;
    validateProperty(scope: any, property: any): ValidationError;
    #private;
}
import MessageSeverity from "./MessageSeverity";
import ValidationError from "../../../validation/ValidationError";
